'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DanmukuCanvas = function () {
  function DanmukuCanvas(canvas) {
    var _this = this;

    _classCallCheck(this, DanmukuCanvas);

    this.clearCanvas = function () {
      return _this.__clearCanvas__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.fixCanvas = function () {
      return _this.__fixCanvas__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.resize = function () {
      return _this.__resize__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.getFont = function () {
      return _this.__getFont__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.draw = function () {
      return _this.__draw__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.formatData = function () {
      return _this.__formatData__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.addDanmuku = function () {
      return _this.__addDanmuku__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.insertDanmuku = function () {
      return _this.__insertDanmuku__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.stop = function () {
      return _this.__stop__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.isSupport = true;
    if (!canvas.getContext) {
      this.isSupport = false;
      console.warn('浏览器不支持canvas');
      return;
    }
    var container = canvas.parentNode;
    if (!this.canvasWidth) {
      // 父容器大小
      var w = container.clientWidth;
      var h = container.clientHeight;
      this.canvasWidth = w;
      this.canvasHeight = h;
      canvas.width = w;
      canvas.height = h;
      canvas.style.width = w;
      canvas.style.height = h;
    }
    var ctx = canvas.getContext('2d');
    this.fixCanvas(canvas);
    this.ctx = ctx;
    this.canvas = canvas;
    this.clearCanvas();
    this.danmukuArr = [];
    this.col = Math.floor(canvas.height / 30);
    this.colTop = parseInt(this.col * 2 / 3, 10);
  }

  DanmukuCanvas.prototype.__clearCanvas__REACT_HOT_LOADER__ = function __clearCanvas__REACT_HOT_LOADER__() {
    this.ctx.clearRect(0, 0, this.canvasWidth, this.canvasHeight);
  };

  DanmukuCanvas.prototype.__fixCanvas__REACT_HOT_LOADER__ = function __fixCanvas__REACT_HOT_LOADER__(t) {
    var i = t.getContext('2d');
    var n = window.devicePixelRatio || 1;
    var e = i.webkitBackingStorePixelRatio || i.mozBackingStorePixelRatio || i.msBackingStorePixelRatio || i.oBackingStorePixelRatio || i.backingStorePixelRatio || 1;
    var a = n / e;
    if (n !== e) {
      var o = t.width;
      var r = t.height;
      t.width = o * a;
      t.height = r * a;
      t.style.width = o + 'px';
      t.style.height = r + 'px';
      i.scale(a, a);
    }
  };

  DanmukuCanvas.prototype.__resize__REACT_HOT_LOADER__ = function __resize__REACT_HOT_LOADER__(canvas) {
    var container = canvas.parentNode;
    var w = container.clientWidth;
    var h = container.clientHeight;
    this.canvasWidth = w;
    this.canvasHeight = h;
    canvas.width = w;
    canvas.height = h;
    canvas.style.width = w;
    canvas.style.height = h;
    this.fixCanvas(canvas);
    this.col = Math.floor(canvas.height / 30);
    this.colTop = parseInt(this.col * 2 / 3, 10);
  };

  DanmukuCanvas.prototype.__getFont__REACT_HOT_LOADER__ = function __getFont__REACT_HOT_LOADER__(size) {
    var ratio = void 0;
    switch (size) {
      case 'small':
        ratio = '14';
        break;
      case 'middle':
        ratio = '20';
        break;
      case 'large':
        ratio = '26';
        break;
      default:
        ratio = '20';
        break;
    }
    return ratio + 'px Arial normal';
  };

  DanmukuCanvas.prototype.__draw__REACT_HOT_LOADER__ = function __draw__REACT_HOT_LOADER__() {
    var _this2 = this;

    if (!this.isSupport) {
      return;
    }
    if (this.timer) {
      return;
    }
    this.timer = setInterval(function () {
      _this2.clearCanvas();
      _this2.ctx.save();
      var arr = _this2.danmukuArr;
      for (var i = 0, len = arr.length; i < len; i += 1) {
        if (arr[i].status) {
          var _arr$i = arr[i],
              content = _arr$i.content,
              x = _arr$i.x,
              y = _arr$i.y;

          _this2.ctx.fillStyle = arr[i].fontColor;
          _this2.ctx.font = _this2.getFont(arr[i].fontSize);
          _this2.ctx.fillText(content, x, y);
          if (arr[i].insert) {
            _this2.ctx.strokeStyle = 'white';
            _this2.ctx.lineCap = 'square';
            _this2.ctx.beginPath();
            _this2.ctx.moveTo(x, y + 3);
            _this2.ctx.lineTo(x + arr[i].textWidth, y + 3);
            _this2.ctx.stroke();
            _this2.ctx.closePath();
          }
          switch (arr[i].model) {
            case 'roll':
              _this2.danmukuArr[i].x = arr[i].x - arr[i].speed;
              if (arr[i].x <= -arr[i].textWidth) {
                _this2.danmukuArr[i].status = false;
              }
              break;
            case 'top':
            case 'bottom':
              _this2.danmukuArr[i].current = _this2.danmukuArr[i].current + 30;
              if (arr[i].current >= 5000) {
                _this2.danmukuArr[i].status = false;
              }
              break;
            default:
              _this2.danmukuArr[i].x = arr[i].x - arr[i].speed;
              if (arr[i].x <= -arr[i].textWidth) {
                _this2.danmukuArr[i].status = false;
              }
              break;
          }
        }
      }
      _this2.ctx.restore();
    }, 30);
  };

  DanmukuCanvas.prototype.__formatData__REACT_HOT_LOADER__ = function __formatData__REACT_HOT_LOADER__(data, insertFlag, index) {
    var positionX = void 0;
    var positionY = void 0;
    var randomCol = void 0;
    if (index) {
      if (index > this.col) {
        randomCol = index % this.col;
      } else {
        randomCol = index;
      }
    } else {
      randomCol = parseInt(Math.random() * (this.col - 1) + 1, 10);
    }
    // const randomCol = parseInt(((Math.random() * (this.col - 1)) + 1), 10);
    this.ctx.font = this.getFont(data.fontSize);
    var tw = this.ctx.measureText(data.content).width;
    var distance = tw + this.canvasWidth;
    switch (data.model) {
      case 'roll':
        positionX = this.canvas.width;
        positionY = randomCol * 30;
        break;
      case 'top':
        positionX = this.canvas.width / 2 - tw / 2;
        positionY = randomCol * 30;
        break;
      case 'bottom':
        positionX = this.canvas.width / 2 - tw / 2;
        if (randomCol > this.colTop) {
          positionY = randomCol * 30;
        } else {
          positionY = (randomCol % this.colTop + this.colTop) * 30;
        }
        break;
      default:
        positionX = this.canvas.width;
        positionY = parseInt(Math.random() * (this.col - 1) + 1, 10) * 30;
        break;
    }
    var danmukuData = _extends({}, data, {
      x: positionX,
      y: positionY,
      textWidth: tw,
      speed: distance / (5 * 33),
      insert: insertFlag,
      current: 0,
      status: true
    });
    return danmukuData;
  };

  DanmukuCanvas.prototype.__addDanmuku__REACT_HOT_LOADER__ = function __addDanmuku__REACT_HOT_LOADER__(data) {
    var _this3 = this;

    var newDanmuku = data.map(function (d, index) {
      var danmukuData = _this3.formatData(d, false, index + 1);
      return danmukuData;
    });
    this.danmukuArr = this.danmukuArr.concat(newDanmuku);
  };

  DanmukuCanvas.prototype.__insertDanmuku__REACT_HOT_LOADER__ = function __insertDanmuku__REACT_HOT_LOADER__(danmu) {
    var data = this.formatData(danmu, true, 0);
    this.danmukuArr.push(data);
  };

  DanmukuCanvas.prototype.__stop__REACT_HOT_LOADER__ = function __stop__REACT_HOT_LOADER__() {
    clearInterval(this.timer);
    this.timer = null;
  };

  return DanmukuCanvas;
}();

var _default = DanmukuCanvas;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(DanmukuCanvas, 'DanmukuCanvas', 'src/util/Canvas.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/util/Canvas.js');
}();

;